clear all;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% SECTION 1: GENERATE PROBLEM (produces data structure)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
global data
data.name='2D_exact1'; 
addpath(data.name);
time=cputime;
geometry_problem % GEOMETRY: p t ID nx ny --> data
                 % PROBLEM:  nu alpha diffuse_op upe --> data
                 %           f d --> data
disp(['Problem setting: ',num2str(cputime-time),'sec.'])
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% SECTION 2: TEST MATRICES, AGREEMENT OF VECTORIZED VERSUS NONVECTORIZED 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if strcmp(data.diffuse_op,'lap_op'), disp('Test for lap_op, Stokes matrices!!!')
%     time=cputime;
%     [A_,B_,E_,b_,c_,a_]=assemblyP1bP1(data.p,data.t,data.nu,data.alpha,data.f);
%     disp(['Matrices assembling: ',num2str(cputime-time),'sec.'])
    time=cputime;
    [A,B,E,b,c,a]=assemblyP1bP1_vecO(data.p,data.t,data.nu,data.alpha,data.f);
    disp(['Matrices assembling: ',num2str(cputime-time),'sec.'])
elseif strcmp(data.diffuse_op,'symgr_op'), disp('Test for symgr_op, Stokes matrices!!!')
    time=cputime;
    [A_,B_,E_,b_,c_,a_]=assemblyP1bP1D(data.p,data.t,data.nu,data.alpha,data.f);
    disp(['Matrices assembling: ',num2str(cputime-time),'sec.'])
    time=cputime;
    [A,B,E,b,c,a]=assemblyP1bP1D_vecO(data.p,data.t,data.nu,data.alpha,data.f);
    disp(['Matrices assembling: ',num2str(cputime-time),'sec.'])
end

% Matrices=[norm(full(A_-A)), norm(full(B_-B)), norm(full(E_-E))]
% Vectors=[norm(full(b_-b)), norm(full(c_-c)), norm(full(a_-a))]
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%